# Tutorial

:project Tutorial: First project

## Janela do Projeto

:position 30,30,40,40

:overlay

### Janela do Projeto

A janela do projeto é aberta quando você cria um novo projeto ou abre um de seus projetos existentes. É aqui que você programa, testa, cria *sprites*, mapas e configura todos os detalhes do seu projeto.

## Navegação

### Navegar no projeto

Uma coluna de ícones está localizada no lado esquerdo da tela. Ela permite abrir rapidamente o editor de código, o editor de *sprites*, mapas, documentação, configurações e opções de publicação do seu projeto.

:highlight #projectview .sidemenu ul

## Seção de código

### Programando e executando

Clique em **Código** para abrir a primeira seção.

:highlight #projectview .sidemenu #menuitem-code

:auto

## Seção de código 2

:navigate projects.code

### Programando e executando

Nesta seção você pode criar seu programa, executar sua aplicação, testar e depurar.
O lado esquerdo da tela é o editor de código, onde você escreverá seu programa.
O lado direito da tela inclui uma visualização de execução na parte superior e um console na parte inferior, onde você pode escrever comandos, verificar variáveis ou modificá-las em tempo real enquanto seu programa está sendo executado.

## Seção de *sprites*

### *Sprites*

Clique em **Sprites** para abrir o editor de *sprites*.

:highlight #projectview .sidemenu #menuitem-sprites

:auto

## Seção de *sprites* 2

:navigate projects.sprites

### *Sprites*

Este é o editor de sprites. *Sprites* são imagens que você pode criar aqui e, em seguida, as referenciar em seu código para desenhá-las na tela. Clique em um *sprite* na lista à esquerda para abri-lo, então use as funções de desenho no lado direito e comece a desenhar.

## Seção de mapas

### Mapas

Clique em **Mapas** para abrir o editor de mapas.

:highlight #projectview .sidemenu #menuitem-maps

:auto

## Seção de mapas 2

:navigate projects.maps

### Mapas

Este é o editor de mapas. Os mapas são frequentemente usados para criar níveis para videogames ou para criar ambientes que podem ser explorados. Eles são criados colocando *sprites* juntos em uma grade. *Sprites* são escolhidos entre aqueles que você projetou na seção *Sprites*.

Clique em "Adicionar Mapa" para criar seu primeiro mapa e começar a desenhar na grade.

## Seção de Documentação

### Documentação

Clique em **Documentação** para abrir o editor de documentos.

:highlight #projectview .sidemenu #menuitem-doc

:auto

## Seção de Documentação 2

:navigate projects.doc

### Documentação

Aqui está o editor de doc (documentação). Sempre que seu projeto for um *plug-in* destinado a ser usado por outras pessoas, ou uma demonstração para a qual deseja adicionar explicações, você pode escrever essa documentação aqui usando a linguagem *markdown*. Os próprios tutoriais do microStudio são criados com este editor!

## Seção de Configurações

### Configurações

Clique em **Configurações** para abrir as configurações do projeto.

:highlight #projectview .sidemenu #menuitem-options

:auto

## Seção de Configurações 2

:navigate projects.options

### Configurações

Nesta seção, você pode editar o título e a URL do seu projeto. Você também pode alterar a palavra secreta usada para manter seu projeto privado enquanto permite que você teste em diferentes dispositivos. Você pode definir a orientação da tela adequada para o seu projeto. Finalmente, você pode convidar seus amigos para contribuir com seu projeto. Tudo que você precisa é enviar um convite ao apelido do seu amigo no microStudio.

## Seção de Publicação

### Publicação

Clique **Publicar** para abrir o painel de opções de publicação.

:highlight #projectview .sidemenu #menuitem-publish

:auto

## Seção de Publicação 2

:navigate projects.publish

### Publicação

Quando seu projeto for concluído, você pode torná-lo publicamente disponível para todos os usuários do microStudio. Você também pode mantê-lo privado e realizar a exportação para HTML5, o que permite publicá-lo em seu próprio site ou em uma plataforma de publicação de jogos.

## Fim

Este tutorial acabou. Agora você pode iniciar o tutorial "Primeiro Projeto" para começar a criar seu primeiro aplicativo com microStudio.
